=begin
 * Name: SiSU information Structuring Universe - Structured information, Serialized Units
 * Author: Ralph@Amissah.com
   * http://www.jus.uio.no/sisu
   * http://www.jus.uio.no/sisu/SiSU/download
 * Description: Document skin for SiSU descriptive pages, ...
 * License: Same as SiSU see http://www.jus.uio.no/sisu
 * Notes: Site default appearance variables set in defaults.rb
     Generic site wide modifications set here scribe_skin.rb, and this file required by other "scribes" instead of defaults.rb
=end
module SiSU_Viz
  require SiSU_lib + '/defaults'
  class Skin
    #% widget
    def widget_search
      true
    end
    def widget_promo
#put  s "#{__LINE__} #{__FILE__}"
      #['sisu','ruby','sisu_search_libre','ruby','open_society']
    end
    #% path
    def path_root
#puts "#{__LINE__} #{__FILE__}"
      './sisu/'                                                                  # the only parameter that cannot be changed here
    end
    def path_rel
#puts "#{__LINE__} #{__FILE__}"
      '../'
    end
    #% url
    def url_home
#puts "#{__LINE__} #{__FILE__}"
      'http://www.jus.uio.no/sisu/'
    end
    def url_site                                                                     # used in pdf header
#puts "#{__LINE__} #{__FILE__}"
      'http://www.jus.uio.no/sisu'
    end
    def url_txt                                                                      # text to go with url usually stripped url
#puts "#{__LINE__} #{__FILE__}"
      'www.jus.uio.no/sisu/'
    end
    def url_home_url
#puts "#{__LINE__} #{__FILE__}"
      '../index.html'
    end
    #def url_root_http
      #root server path info, used in document information
    #end
    #% color
    def color_band1
      '"#ffffff"'
    end
    def color_band2
      '"#ffffff"'
    end
    #% text
    def text_hp
      '&nbsp;SiSU'
    end
    def text_home
      'SiSU'
    end
    #% icon
    def icon_home_button
      'sisu.png'
    end
    def icon_home_banner
      icon_home_button
    end
    #% banner
    def banner_home_button
      %{<table summary="home button" border="0" cellpadding="3" cellspacing="0"><tr><td align="left" bgcolor="#ffffff"><a href="#{url_site}/">#{png_home}</a></td></tr></table>\n}
    end
    def banner_home_and_index_buttons
      %{<table><tr><td width="20%"><table summary="home and index buttons" border="0" cellpadding="3" cellspacing="0"><tr><td align="left" bgcolor="#ffffff"><a href="#{url_site}/" target="_top">#{png_home}</a>#{table_close}</td><td width="60%"><center><center><table summary="buttons" border="1" cellpadding="3" cellspacing="0"><tr><td align="center" bgcolor="#ffffff"><font face="arial" size="2"><a href="toc" target="_top">&nbsp;This&nbsp;text&nbsp;sub-&nbsp;<br />&nbsp;Table&nbsp;of&nbsp;Contents&nbsp;</a></font>#{table_close}</center></center></td><td width="20%">&nbsp;#{table_close}}
    end
    def banner_band
      %{<table summary="band" border="0" cellpadding="3" cellspacing="0"><tr><td align="left" bgcolor="#ffffff"><a href="#{url_site}/" target="_top">#{png_home}</a>#{table_close}}
    end
  end
  class TeX
    def header_center
      "\\chead{\\href{#{@vz.url_site}/}{www.jus.uio.no/sisu/}}"
    end
    def home_url
      "\\href{#{@vz.url_site}/}{www.jus.uio.no/sisu/}"
    end
    def home
      "\\href{#{@vz.url_site}/}{Ralph Amissah}"
    end
    def owner_chapter
      'Document owner details'
    end
  end
end
__END__
